﻿#region System Namespace
using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Threading;
#endregion System Namespace

#region Foreign Namespace
#endregion Foreign Namespace

#region Styx Namespace
using System.Windows;
using System.Windows.Forms;
using Styx;
using Styx.Helpers;
using Styx.Plugins;
using Styx.Common;
using Styx.CommonBot;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using MessageBox = System.Windows.MessageBox;
using MessageBoxOptions = System.Windows.MessageBoxOptions;
#endregion Styx Namespace

namespace AutoReady
{
    public class AutoReady : HBPlugin
    {
        public override string Name
        {
            get { return "AutoReady"; }
        }

        public override string Author
        {
            get { return "Tictoc"; }
        }

        public override Version Version
        {
            get { return new Version(1, 0); }
        }

        public override bool WantButton
        {
            get { return false; }
        }

        public override void Initialize()
        {
            Lua.Events.AttachEvent("LFG_PROPOSAL_SHOW", LfgDungeonReady);
            Lua.Events.AttachEvent("READY_CHECK", Ready);
            Lua.Events.AttachEvent("LFG_ROLE_CHECK_SHOW", LfgRoleCheckShow);
            Lua.Events.AttachEvent("RESURRECT_REQUEST", Resurrect);
            Logging.Write("Loaded AutoReady Version " + Version);
        }

        public void Resurrect(object sender, LuaEventArgs args)
        {
            Random r = new Random();
            Logging.Write("[ResurrectRequest]: 'Ressurect Request' menu detected, clicking Accept in 1.5 - 3.5 seconds");
            Thread.Sleep(r.Next(1500, 3500));
            Lua.DoString("RunMacroText(\"/click StaticPopup1Button1\");");
        }
        public void Ready(object sender, LuaEventArgs args)
        {
            Random r = new Random();
            Logging.Write("[ReadyCheck]: 'Ready Check' menu detected, clicking Ready in 1.5 - 3.5 seconds");
            Thread.Sleep(r.Next(1500, 3500));
            Lua.DoString("RunMacroText(\"/click ReadyCheckFrameYesButton\");");
        }

        public void LfgRoleCheckShow(object sender, LuaEventArgs args)
        {
            Random r = new Random();
            Logging.Write("[RollCheck]: 'Role Check' menu detected, clicking Ready in 2.5 - 4.5 seconds");
            Thread.Sleep(r.Next(500, 1000));

            #region

            //RolePollPopupRoleButtonDPS
            //RolePollPopupRoleButtonHealer 
            //RolePollPopupRoleButtonTank

            #endregion

            Lua.DoString("RunMacroText(\"/click RolePollPopupRoleButtonDPS\");");
            Thread.Sleep(r.Next(2500, 4500));
            Lua.DoString("RunMacroText(\"/click RolePollPopupAcceptButton\");");

        }

        public void LfgDungeonReady(object sender, LuaEventArgs args)
        {
            //MessageBox.Show("Dungeon Menu Popup Detected!, Joining Dungeon", "AutoReady", MessageBoxButton.OK, MessageBoxImage.Information, MessageBoxResult.OK, MessageBoxOptions.DefaultDesktopOnly);
            Random r = new Random();
            Logging.Write("[DungeonCheck]: 'Dungeon Proposal' menu detected, clicking 'Enter' Dungeon Button in 3.5 - 5.5 seconds");
            Thread.Sleep(r.Next(3500, 5500));
            Lua.DoString("RunMacroText(\"/click LFGDungeonReadyDialogEnterDungeonButton\");");
        }

	public override void Dispose()
        {
            Lua.Events.DetachEvent("LFG_PROPOSAL_SHOW", LfgDungeonReady);
            Lua.Events.DetachEvent("READY_CHECK", Ready);
            Lua.Events.DetachEvent("LFG_ROLE_CHECK_SHOW", LfgRoleCheckShow);
            Lua.Events.DetachEvent("RESURRECT_REQUEST", Resurrect);
            Logging.Write("AutoReady finished");
        }
	
	public override void Pulse()
        {
        }
    }
}
